package controller;

import java.awt.AWTException;

import jssc.SerialPort;
import jssc.SerialPortException;
import jssc.SerialPortTimeoutException;

import java.io.IOException;


public class VolumeControl {
    public static void main(String[] args) throws AWTException, IOException, InterruptedException, SerialPortException{
        final String filePathVolumeIncrease = "/Users/patrickmccabe/Documents/workspace"
                + "/volume/src/controller/volume_increase.sh";
        final String filePathVolumeDecrease = "/Users/patrickmccabe/Documents/workspace"
                + "/volume/src/controller/volume_decrease.sh";
        final String filePathToggleMute = "/Users/patrickmccabe/Documents/workspace"
                + "/volume/src/controller/ToggleMute.sh";
        final String filePathPlayPause = "/Users/patrickmccabe/Documents/workspace"
                + "/volume/src/controller/PlayPause.sh";
        Boolean connected = false;
        
        final SerialPort serialPort = new SerialPort("/dev/tty.volume-DevB");

        while(true){
            while(!connected){
                System.out.println("not connected");
                try {
                    serialPort.openPort();
                    serialPort.setParams(9600, 8, 1, 0);
                    connected = true;
                    System.out.println("connected");
                }
                catch (Exception ex){
                    connected = false;
                }
                Thread.sleep(10);
            }


            try {
                char message = (char)(serialPort.readBytes(1,600))[0];
                System.out.println(message);
                if(message == Message.INCREASE.getValue()){
                    //System.out.println("increase");
                    Runtime.getRuntime().exec(filePathVolumeIncrease);
                } else if(message == Message.DECREASE.getValue()){
                    //System.out.println("decrease");
                    Runtime.getRuntime().exec(filePathVolumeDecrease);
                }
                else if(message == Message.TOGGLE_MUTE.getValue()){
                    //System.out.println("toggle mute");
                    Runtime.getRuntime().exec(filePathPlayPause);
                }
                else if(message == Message.ALIVE.getValue()){
                    // do nothing with an ALIVE message
                }
            }  catch (SerialPortTimeoutException e) {
                connected = false;
                serialPort.closePort();
            }   catch (SerialPortException e) {
                e.printStackTrace();
            }      
        }
    }
}
